/*
 *	System Dependent Message Headers
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this program is strictly prohibited.
 *
 *      Copyright (c) 1987, 1988, 1989 FairCom Corporation
 *	(Subject to limited distribution and
 *	 restricted disclosure only.)
 *	*** ALL RIGHTS RESERVED ***
 *
 *	4006 West Broadway
 *	Columbia, MO 65203
 *
 *
 *	c-tree(R)	Version 4.3
 *			Release C
 *			February 7, 1989 17:30
 *
 */

/*
 * LTYPE is the number of bytes from the beginning of the message to
 * the c-tree portion of the message.
*/
#define LTYPE	0

#define LSN		1
#define RCV		2
#define DATA_SIZE	534
#define SPXHDR_SIZE	42
#define REV_SPXHDR_SIZE	0x002A
#define REV_TOTAL_SIZE	0x0240

union makepv {
	int	(far *mpf)();
	UCOUNT	mpw[2];
} mp;

typedef struct {
	TEXT	network[4];
	TEXT	node[6];
	TEXT	socket[2];
} IPXADR;

typedef struct {
	UCOUNT	checksum;
	UCOUNT	length;	
	TEXT	transportControl;
	TEXT	packetType;
	TEXT	destinationNetwork[4];
	TEXT	destinationNode[6];
	UCOUNT	destinationSocket;
	TEXT	sourceNetwork[4];
	TEXT	sourceNode[6];	
	UCOUNT	sourceSocket;
	TEXT	connectionControl;
	TEXT	dataStreamType;
	UCOUNT	sourceConnectionID;
	UCOUNT	destConnectionID;
	UCOUNT	sequenceNumber;	
	UCOUNT	acknowledgeNumber;
	UCOUNT	allocationNumber;
} SPXHDR;

typedef struct {
	UCOUNT	address[2];
	UCOUNT	size;
} ECBFRAG;

typedef struct {
	UCOUNT			linkAddress[2];
	UCOUNT			ESRAddress[2];
	TEXT			inUseFlag;
	TEXT			completionCode;
	UCOUNT			socketNumber;
	TEXT			IPXWorkspace[4];
	TEXT			driverWorkspace[12];
	TEXT			immediateAddress[6];
	UCOUNT			fragmentCount;
	ECBFRAG			fragmentDescriptor[2];
} ECB;

#define IPXdatadr	IPXGetDataAddress
#define SPXlisten	SPXListenForSequencedPacket
#define SPXlsncon	SPXListenForConnection
#define SPXinit		SPXInitialize
#define IPXopen		IPXOpenSocket
#define IPXrelq		IPXRelinquishControl
#define SPXsend		SPXSendSequencedPacket
#define SPXstatus	SPXGetConnectionStatus
#define IPXcancel	IPXCancelEvent
#define SPXestcon	SPXEstablishConnection
#define SPXabort	SPXAbortConnection
#define IPXclose	IPXCloseSocket


#define SPX_CLEAN_TERMINATION		0xFE

#define SPX_IS_INSTALLED			0xFF
#define SPX_NOT_INSTALLED			0x00
#define SPX_CONNECTION_OK			0x00
#define SPX_CONNECTION_STARTED		0x00
#define SPX_CONNECTION_ESTABLISHED	0x00
#define SPX_PACKET_SUCCESSFUL		0x00
#define SPX_SOCKET_NOT_OPENED		0xFF
#define SPX_MALFORMED_PACKET		0xFD
#define SPX_PACKET_OVERFLOW			0xFD
#define SPX_LISTEN_CANCELED			0xFC
#define SPX_CONNECTION_TABLE_FULL	0xEF
#define SPX_INVALID_CONNECTION		0xEE
#define SPX_NO_ANSWER_FROM_TARGET	0xED
#define SPX_CONNECTION_FAILED		0xED
#define SPX_CONNECTION_TERMINATED	0xED
#define SPX_TERMINATED_POORLY		0xEC

int xerr;
UCOUNT soknum = 0x802f;
UCOUNT ecbpos;
ECB   *savecb;
