# Make library for c-tree
# invoke with MAKESRV.BAT

COMPILER=cl /c /Gs
ASM=masm
MM=S
CM=/AS
AM=SMALL
D=SSRV
P=/I .\ /I ..\ /I ..\msc
LINK=link
NV=..\nov$$(MM)vap
LN=ctslib
SLIB=$(LN).lib

# library modules

$(D)\ctvrc2.obj: ..\ctvrc2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvapf$(MM).obj: ctvapf$(MM).asm
	$(ASM) $*;
	copy $*.obj $(D)
	del $*.obj

$(D)\ctdelk.obj: ..\ctdelk.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctaddk.obj: ..\ctaddk.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctupdt.obj: ..\ctupdt.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctfrac.obj: ..\ctfrac.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsrch.obj: ..\ctsrch.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctdatf.obj: ..\ctdatf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctkeyf.obj: ..\ctkeyf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctkrnl.obj: ..\ctkrnl.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctcomp.obj: ..\ctcomp.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsrvr.obj: ..\ctsrvr.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrcu.obj: ..\ctvrcu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctinit.obj: ..\ctinit.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctdelf.obj: ..\ctdelf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb2$(MM).obj: ctclb2$(MM).c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctsrve.obj: ctsrve.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctclib$(MM).obj: ctclib$(MM).c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctsmsg$(MM).obj: ctsmsg$(MM).c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctslok.obj: ..\ctslok.c    # low level disk interface
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\$(SLIB): $(D)\ctvrc2.obj \
			$(D)\ctdelk.obj $(D)\ctaddk.obj $(D)\ctupdt.obj \
			$(D)\ctsrch.obj $(D)\ctdatf.obj $(D)\ctkeyf.obj \
			$(D)\ctkrnl.obj $(D)\ctcomp.obj $(D)\ctvrcu.obj \
			$(D)\ctinit.obj $(D)\ctdelf.obj $(D)\ctclb2$(MM).obj \
			$(D)\ctslok.obj $(D)\ctclib$(MM).obj $(D)\ctfrac.obj
	cd $(D)
	del $(LN).bak
	ren $(SLIB) $(LN).bak
	echo $(SLIB) > lrsp
	echo y >> lrsp
	echo +ctvrc2 & >> lrsp
	echo +ctdelk+ctaddk+ctupdt & >> lrsp
	echo +ctfrac+ctsrch+ctdatf & >> lrsp
	echo +ctkeyf+ctkrnl+ctcomp+ctvrcu & >> lrsp
	echo +ctinit+ctdelf+ctclb2$(MM)+ctslok+ctclib$(MM) >> lrsp
	echo $(LN).m >> lrsp
	echo $(SLIB) >> lrsp
	lib @lrsp
	del lrsp
	cd ..

$(D)\ctsrvr$(MM).vap: $(D)\$(SLIB) $(D)\ctsrvr.obj $(D)\ctsrve.obj \
		$(D)\ctsmsg$(MM).obj $(D)\ctvapf$(MM).obj
	cd $(D)
	$(LINK) ctvapf$(MM)+ctsrvr+ctsrve+ctsmsg$(MM),ctsrvr$(MM).vap/m,,$(SLIB)+$(NV);
	cd ..

#end

